/***************************************************************

  BayCom(R)        Packet-Radio fuer IBM PC

  OpenBayCom-Mailbox

  ------------------------------
  Kommandoprozessor und Zubehoer
  ------------------------------


  Copyright (C)       Florian Radlherr
                      Taubenbergstr. 32
                      83627 Warngau

  Alle Rechte vorbehalten / All Rights Reserved

 ***************************************************************/
//20000606 DK2UI  new function cut() to remove invalid chars from line end

#include "baycom.h"

/*---------------------------------------------------------------------------*/

void subst (char *s, char i, char j)
//*************************************************************************
//
//  Replaces all matching characters by another in a string
//
//  DH3MB: replaced strchr() by strrchr(), so replacing with a 0-byte
//        is now possible
//
//*************************************************************************
{ char *p;
 while ((p = strrchr (s, i)) != NULL) *p = j;
}

void subst1 (char *s, char i, char j) // dk2ui, only first match
{ char *p;
 if ((p = strchr (s, i)) != NULL) *p = j;
}

/*---------------------------------------------------------------------------*/
void rmcrlf (char *s)
//*************************************************************************
//
//  Removes cr or linefeed from a line
//
//*************************************************************************
{
  subst1 (s, LF, 0);
  subst1 (s, CR, 0);
}

/*---------------------------------------------------------------------------*/

int blkill (char *s)
{ unsigned int i = 0;
  while (s[i] == CR || s[i] == ' ' || s[i] == ',') i++;
  return i;
}

/*---------------------------------------------------------------------------*/
/*
#ifdef __DOS16__
char *blankweg (char *s)
{ if ( ! s) trace (tr_abbruch, "skip", "NULL pointer");
  s += blkill (s);
  if (s = strchr (s, ' ')) != NULL)
  { *s++ = 0;
    s += blkill (s);
  }
  return s;
}
#endif
*/

char *skip (char *s)
{ if ( ! s) trace (tr_abbruch, "skip", "NULL pointer");
  if ( ! *s) return s;
  char *p;
  while (*s == ' ' || *s == ',') s++;
  if ((p = strchr (s, ' ')) != NULL)
  { *p++ = 0;
    while (*p == ' ' || *p == ',') p++;
    s = p;
    return s;
  }
  else if ((p = strchr (s, ',')) != NULL)
  { *p++ = 0;
    while (*p == ' ' || *p == ',') p++;
    s = p;
    return s;
  }
  else s += strlen (s);
  return s;
}

/*---------------------------------------------------------------------------*/

void cut_all (char *s) //dk2ui
//*************************************************************************
//
//  Removes blank
//
//*************************************************************************
{
  if (*s)
  {
    unsigned int ui = strlen (s);
    while (ui && s[ui - 1] <= ' ') ui--;
    s[ui] = 0;
  }
}

/*---------------------------------------------------------------------------*/

void cutblank (char *s) //dk2ui
//*************************************************************************
//
//  Removes blank and tabulators
//
//*************************************************************************
{
  if (*s)
  {
    unsigned int ui = strlen (s);
    while (ui && (s[ui - 1] == ' ' || s[ui - 1] == '\t')) ui--;
    s[ui] = 0;
  }
}

/*---------------------------------------------------------------------------*/

int nextdez (char **bf)
{ int i = -1, a = 0;
  if ( ! (**bf)) return -1;
  while (**bf && ((**bf < '0') || (**bf > '9'))) (*bf)++;
  if ( ! (**bf)) return -1;
  i = atoi (*bf);
  while ((**bf >= '0') && (**bf <= '9'))
  { (*bf)++;
    a++;
  }
  (*bf) += blkill (*bf);
  if (a) return i;
  else  return -1;
}

/*---------------------------------------------------------------------------*/

int readcmd (char *beftab[], char **buffer, unsigned int minimum)
//*************************************************************************
//
//  vergleicht die Kommandos in einer Befehlstabelle mit einem
//  Stringanfang. Wird das Kommando gefunden, so wird der String-
//  zeiger entsprechend nachgefuehrt.
//
//  beftab[] = Pointer-Array, dessen Eintraege auf die Befehls-Strings
//           zeigen. Das Array muss an letzter Stelle stets mit
//           dem NULL-Pointer besetzt sein.
//  *buffer    Zeiger auf einen String, in dem am Anfang der Befehl
//           steht.
//  minimum    Gibt die Anzahl der mindestens ~uebereinstimmenden
//           Zeichen an, damit ein Befehl als solcher akzeptiert
//           wird.
//           0 bedeutet, dass der Befehl stets mit String-Ende (\0)
//           oder mit einem Blank abgeschlossen sein muss (fuer Node)
//
//*************************************************************************
{ unsigned int i = 0, j = 0, cmd = 0, maxcmd = 0;
  while (beftab[i])
  { j = 0;
    while (beftab[i][j] && (toupper (buffer[0][j]) == beftab[i][j])) j++;
    i++;
    if (j > maxcmd && j >= minimum)
    { // if(minimum || (buffer[0][j]==0) || (buffer[0][j]==' '))
      if ( ! buffer[0][j] || buffer[0][j] == ' ' || buffer[0][j] == '=')
      { maxcmd = j;
        cmd = i;
      }
    }
  }
  *buffer += maxcmd;
  *buffer += blkill (*buffer);
  return cmd;
}

/*---------------------------------------------------------------------------*/
